<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/11/2008 *
 * ===================                          Last change: 09/11/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : tpl-validator.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Only validates templates for correctness         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Validiert Templates auf korrektes HTML           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

if ($_SERVER['argc'] < 2) {
	print "Usage: ".basename(__FILE__)." <template> [--write]\n\n";
	print "Validates a template against the DOM model. Use --write with caution!\n";
	exit;
} elseif (strpos($_SERVER['argv'][1], '/js/') > 0) {
	// Not parsing JavaScript templates!
	print "Warning: Not parsing JavaScript ".$_SERVER['argv'][1].".\n";
	exit;
}

print "Validating template ".$_SERVER['argv'][1]."...\n";

$doc = new DOMDocument();
$doc->formatOutput = true;
$doc->preserveWhiteSpace = false;
$doc->encoding = 'utf-8';
$doc->xmlVersion = '1.1';
$doc->loadHTMLFile($_SERVER['argv'][1]);

$data = $doc->saveHTML();
$newData = str_replace("<br>", "<br />\n", $data);
$newData = str_replace("\n\n", "\n", $newData);

$array = explode("\n", $newData);
array_shift($array);
array_shift($array);
unset($array[count($array) - 1]);
unset($array[count($array) - 1]);

$newData = implode("\n", $array)."\n";

// Has a template changed?
if ($data != $newData) {
	// Has changed
	print "Template ".$_SERVER['argv'][1]." has maybe issues.\n";
} else {
	// Has not changed
	print "Template ".$_SERVER['argv'][1]." might be issue-free.\n";
}

if ((isset($_SERVER['arv'][2])) && (strtolower($_SERVER['arv'][2]) == '--write')) {
	print "Writing document...\n";
	file_put_contents($_SERVER['argv'][1], $data);
} // END - if

// [EOF]
?>
